//+------------------------------------------------------------------+
//|                                               Imolenmaker_v1.mq4 |
//|                                           Copyright  2010 ,.... |
//|                                             http://www.linka.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010 ,...."
#property link      "http://www.linka.net"


extern bool On = true;
extern bool buy = true;
extern int x_pips = 115;
extern int y_pips = 300;

extern double lots = 0.1;
extern int dSL = 10000;
extern int slippage = 10;
extern int magic = 248248;
extern string comment = "Imolenmaker_v1";
                

int digit;
double point;
               
               
               
///-------------------------------------------------------------------------------------------------------------------------------------------
int init() {
 
digit = Digits;
point = Point;


tracker() ;
seeker ();

 return (0);
}
///-------------------------------------------------------------------------------------------------------------------------------------------
int start() {
 

tracker() ;
seeker ();

            
}
///----------------------------------------------------------------------------------------------------------------------------------------------
void tracker () {

for (int i = 0; i < OrdersTotal(); i++) {

 OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
 
 if(OrderSymbol() != Symbol()) continue;
 if(OrderMagicNumber() != magic) continue;
  
 if (OrderType() == OP_BUY) {
 
  trail_long();
 
 }else if (OrderType() == OP_SELL) {
  
  trail_short();
 
 }

}

}
///----------------------------------------------------------------------------------------------------------------------------------------------
void trail_long () {

double sl_line = NormalizeDouble(Bid - x_pips*point,digit);

if (OrderStopLoss() < sl_line) {
 
  OrderModify(OrderTicket(),OrderOpenPrice(),sl_line,OrderTakeProfit(),0);

}

}
///----------------------------------------------------------------------------------------------------------------------------------------------
void trail_short () {

double sl_line = NormalizeDouble(Ask + x_pips*point,digit);

if (OrderStopLoss() > sl_line) {
 
  OrderModify(OrderTicket(),OrderOpenPrice(),sl_line,OrderTakeProfit(),0);

}

}
///----------------------------------------------------------------------------------------------------------------------------------------------
void seeker () {

if(!On) return;

  if (buy_signal()) {
  
     buy();
  }
  if (sell_signal()) {
  
   sell();  
  }
    
}
///----------------------------------------------------------------------------------------------------------------------------------------------
bool buy_signal () {
  
if(!buy) return;
  
if(last_long()) {

 if((OrderOpenPrice() - Bid) > y_pips*point) return(true);
 
 if((Bid - OrderOpenPrice()) > x_pips*point) {
 
  trail_long();
 
  return(true);
 }

}  
  
  
return (false);

}
///----------------------------------------------------------------------------------------------------------------------------------------------
bool sell_signal () {

if(buy) return;

if(last_short()) {

 if((Ask - OrderOpenPrice()) > y_pips*point) return(true);
 
 if((OrderOpenPrice() - Ask) > x_pips*point){
 
  trail_short();
 
  return(true);
 }

}  
  
return (false);

}
///----------------------------------------------------------------------------------------------------------------------------------------------
bool last_long () {

for (int i = OrdersTotal(); i > 0 ; i--) {

 OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
 
 if(OrderSymbol() != Symbol()) continue;
 if(OrderMagicNumber() != magic) continue;
 
  if (OrderType() == OP_BUY) return (true);

}

return (false);
}
///----------------------------------------------------------------------------------------------------------------------------------------------
bool last_short () {

for (int i = OrdersTotal(); i > 0 ; i--) {

 OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
 
 if(OrderSymbol() != Symbol()) continue;
 if(OrderMagicNumber() != magic) continue;
 
  if (OrderType() == OP_SELL) return (true);

}

return (false);
}
///----------------------------------------------------------------------------------------------------------------------------------------------
void buy () {
 
double open_price = Ask;
double sl = NormalizeDouble(open_price - dSL*point,digit);
double tp = 0;//NormalizeDouble(fma + TP*point,digit);

int ticket = OrderSend(Symbol(),OP_BUY,lots,open_price,slippage,sl,tp,comment,magic,0,Blue);
 

}
///----------------------------------------------------------------------------------------------------------------------------------------------
void sell () {
 
double open_price = Bid;
double sl = NormalizeDouble(open_price + dSL*point,digit);
double tp = 0;//NormalizeDouble(fma - TP*point,digit);

int ticket = OrderSend(Symbol(),OP_SELL,lots,open_price,slippage,sl,tp,comment,magic,0,Red);

}
///-------------------------------------------------------------------------------------------------------------------------------------------
int deinit() {
 
 return (0);
}
///-------------------------------------------------------------------------------------------------------------------------------------------